//--- xrmb:downloadclientslist ---

//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//SLAHAM: ADDED/MODIFIED DownloadClientsCtrl =>

#include "stdafx.h"
#include "emule.h"
#include "emuledlg.h"
#include "DownloadClientsCtrl.h"
#include "ClientDetailDialog.h"
#include "MemDC.h"
#include "MenuCmds.h"
#include "FriendList.h"
#include "TransferWnd.h"
#include "ChatWnd.h"
#include "UpDownClient.h"
#include "UploadQueue.h"
#include "ClientCredits.h"
#include "PartFile.h"
#include "Kademlia/Kademlia/Kademlia.h"
#include "SharedFileList.h"
#include "Addons/Argos/Argos.h" // X-Ray :: Argos

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif


IMPLEMENT_DYNAMIC(CDownloadClientsCtrl, CMuleListCtrl)

BEGIN_MESSAGE_MAP(CDownloadClientsCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_WM_SYSCOLORCHANGE()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMDblclkDownloadClientlist)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnGetDispInfo)
END_MESSAGE_MAP()

CDownloadClientsCtrl::CDownloadClientsCtrl()
	: CListCtrlItemWalk(this)
{
	SetGeneralPurposeFind(true, false);
}

void CDownloadClientsCtrl::Init()
{
	SetName(_T("DownloadClientsCtrl"));

	CImageList ilDummyImageList; //dummy list for getting the proper height of listview entries
	ilDummyImageList.Create(1, theApp.GetSmallSytemIconSize().cy,theApp.m_iDfltImageListColorFlags|ILC_MASK, 1, 1); 
	SetImageList(&ilDummyImageList, LVSIL_SMALL);
	ASSERT( (GetStyle() & LVS_SHAREIMAGELISTS) == 0 );
	ilDummyImageList.Detach();

	SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP);

	InsertColumn(0,	GetResString(IDS_QL_USERNAME), LVCFMT_LEFT, 165);
	InsertColumn(1,	GetResString(IDS_CD_CSOFT), LVCFMT_LEFT, 90); 
	InsertColumn(2,	GetResString(IDS_FILE), LVCFMT_LEFT, 235);
	InsertColumn(3,	GetResString(IDS_DL_SPEED), LVCFMT_LEFT, 65);
	InsertColumn(4, GetResString(IDS_AVAILABLEPARTS), LVCFMT_LEFT, 150);
	InsertColumn(5,	GetResString(IDS_CL_TRANSFDOWN), LVCFMT_LEFT, 115);
	InsertColumn(6,	GetResString(IDS_CL_TRANSFUP), LVCFMT_LEFT, 115);
	InsertColumn(7,	GetResString(IDS_META_SRCTYPE), LVCFMT_LEFT, 60);
	InsertColumn(8,	GetResString(IDS_COUNTRY),LVCFMT_LEFT, 100); // X-Ray :: IP2Country
	InsertColumn(9, GetResString(IDS_ARGOS),LVCFMT_LEFT,100); // X-Ray :: Argos


	SetAllIcons();
	Localize();
	LoadSettings();

	// Barry - Use preferred sort order from preferences
	SetSortArrow();

	// X-Ray :: Argos :: Start
	if (!thePrefs.UseArgosSystem())
		HideColumn(9);
	// X-Ray :: Argos :: End
}

CDownloadClientsCtrl::~CDownloadClientsCtrl()
{
}

void CDownloadClientsCtrl::SetAllIcons() 
{
	m_ImageList.DeleteImageList();
	m_ImageList.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
	m_ImageList.SetBkColor(CLR_NONE);
	m_ImageList.Add(CTempIconLoader(_T("ClientEDonkey")));
	m_ImageList.Add(CTempIconLoader(_T("ClientCompatible")));
	m_ImageList.Add(CTempIconLoader(_T("ClientEDonkeyPlus")));
	m_ImageList.Add(CTempIconLoader(_T("ClientCompatiblePlus")));
	m_ImageList.Add(CTempIconLoader(_T("Friend")));
	m_ImageList.Add(CTempIconLoader(_T("ClientMLDonkey")));
	m_ImageList.Add(CTempIconLoader(_T("ClientMLDonkeyPlus")));
	m_ImageList.Add(CTempIconLoader(_T("ClientEDonkeyHybrid")));
	m_ImageList.Add(CTempIconLoader(_T("ClientEDonkeyHybridPlus")));
	m_ImageList.Add(CTempIconLoader(_T("ClientShareaza")));
	m_ImageList.Add(CTempIconLoader(_T("ClientShareazaPlus")));
	m_ImageList.Add(CTempIconLoader(_T("ClientAMule")));
	m_ImageList.Add(CTempIconLoader(_T("ClientAMulePlus")));
	m_ImageList.Add(CTempIconLoader(_T("ClientLPhant")));
	m_ImageList.Add(CTempIconLoader(_T("ClientLPhantPlus")));
	m_ImageList.Add(CTempIconLoader(_T("ExtendedProtocolOvl"))); // X-Ray :: CorrectAppIcons
	// X-Ray :: EnhancedClientRecognization :: Start
	m_ImageList.Add(CTempIconLoader(_T("CLIENTHYRANODE")));
	m_ImageList.Add(CTempIconLoader(_T("CLIENTHYRANODEPLUS")));
	m_ImageList.Add(CTempIconLoader(_T("CLIENTPLUS")));
	m_ImageList.Add(CTempIconLoader(_T("CLIENTPLUSPLUS")));
	m_ImageList.Add(CTempIconLoader(_T("CLIENTTRUSTYFILES")));
	m_ImageList.Add(CTempIconLoader(_T("CLIENTTRUSTYFILESPLUS")));
	m_ImageList.Add(CTempIconLoader(_T("CLIENTXMULE")));
	m_ImageList.Add(CTempIconLoader(_T("CLIENTXMULEPLUS")));
	// X-Ray :: EnhancedClientRecognization :: End
	// X-Ray :: Argos :: Start
	m_ImageList.Add(CTempIconLoader(_T("ARGOS_BANNED_SOFT")));
	m_ImageList.Add(CTempIconLoader(_T("ARGOS_BANNED_SOFT2")));
	m_ImageList.Add(CTempIconLoader(_T("ARGOS_LEECHER")));
	m_ImageList.Add(CTempIconLoader(_T("ARGOS_BANNED")));
	// X-Ray :: Argos :: End
	m_ImageList.SetOverlayImage(m_ImageList.Add(CTempIconLoader(_T("ClientSecureOvl"))), 1);
	m_ImageList.SetOverlayImage(m_ImageList.Add(CTempIconLoader(_T("OverlayObfu"))), 2);
	m_ImageList.SetOverlayImage(m_ImageList.Add(CTempIconLoader(_T("OverlaySecureObfu"))), 3);
}

void CDownloadClientsCtrl::Localize()
{
	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	CString strRes;

	strRes = GetResString(IDS_QL_USERNAME);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(0, &hdi);

	strRes = GetResString(IDS_CD_CSOFT);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(1, &hdi);

	strRes = GetResString(IDS_FILE);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(2, &hdi);

	strRes = GetResString(IDS_DL_SPEED);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(3, &hdi);
	
	strRes = GetResString(IDS_AVAILABLEPARTS);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(4, &hdi);

	strRes = GetResString(IDS_CL_TRANSFDOWN);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(5, &hdi);

	strRes = GetResString(IDS_CL_TRANSFUP);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(6, &hdi);

	strRes = GetResString(IDS_META_SRCTYPE);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(7, &hdi);

	// X-Ray :: IP2Country :: Start
	strRes = GetResString(IDS_COUNTRY);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(8, &hdi);
	// X-Ray :: IP2Country :: End

	// X-Ray :: Argos :: Start
	strRes = GetResString(IDS_ARGOS);
	hdi.pszText = const_cast<LPTSTR>((LPCTSTR)strRes);
	pHeaderCtrl->SetItem(9, &hdi);
	// X-Ray :: Argos :: End
}

void CDownloadClientsCtrl::AddClient(CUpDownClient* client)
{
	if(!theApp.emuledlg->IsRunning())
		return;
       
	InsertItem(LVIF_TEXT|LVIF_PARAM, GetItemCount(), client->GetUserName(), 0, 0, 1, (LPARAM)client);
	RefreshClient(client);
	// X-Ray :: RollUpCtrl :: Start
	/*
	theApp.emuledlg->transferwnd->UpdateListCount(CTransferWnd::wnd2Downloading, GetItemCount()); 
	*/
	theApp.emuledlg->transferwnd->UpdateExtendedHeader();
	// X-Ray :: RollUpCtrl :: End
}

void CDownloadClientsCtrl::RemoveClient(CUpDownClient* client)
{
	if(!theApp.emuledlg->IsRunning())
		return;

	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	int result = FindItem(&find);
	if (result != -1)
		DeleteItem(result);
	// X-Ray :: RollUpCtrl :: Start
	/*
	theApp.emuledlg->transferwnd->UpdateListCount(CTransferWnd::wnd2Downloading, GetItemCount()); 
	*/
	theApp.emuledlg->transferwnd->UpdateExtendedHeader();
	// X-Ray :: RollUpCtrl :: End
}

void CDownloadClientsCtrl::RefreshClient(CUpDownClient* client)
{
	if( !theApp.emuledlg->IsRunning() )
		return;
	
	//MORPH START - SiRoB, Don't Refresh item if not needed 
	if( theApp.emuledlg->activewnd != theApp.emuledlg->transferwnd  || theApp.emuledlg->transferwnd->downloadclientsctrl.IsWindowVisible() == false ) 
		return; 
	//MORPH END   - SiRoB, Don't Refresh item if not needed 
	
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)client;
	int result = FindItem(&find);
	if (result != -1)
		Update(result);
	return;
}

#define DLC_DT_TEXT (DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS)

void CDownloadClientsCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	if (!theApp.emuledlg->IsRunning())
		return;
	if (!lpDrawItemStruct->itemData)
		return;

	// X-Ray :: Optimizations :: Start - Don't draw hidden Rect
	RECT clientRect;
	GetClientRect(&clientRect);
	CRect cur_rec(lpDrawItemStruct->rcItem);
	if ((cur_rec.top < clientRect.top || cur_rec.top > clientRect.bottom) && (cur_rec.bottom < clientRect.top || cur_rec.bottom > clientRect.bottom))
		return;
	// X-Ray :: Optimizations :: End - Don't draw hidden Rect

	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	BOOL bCtrlFocused = ((GetFocus() == this) || (GetStyle() & LVS_SHOWSELALWAYS));
	if (lpDrawItemStruct->itemState & ODS_SELECTED) {
		if (bCtrlFocused)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);
	}
	else
		odc->SetBkColor(GetBkColor());
	const CUpDownClient* client = (CUpDownClient*)lpDrawItemStruct->itemData;
	CMemDC dc(odc, &lpDrawItemStruct->rcItem);
	CFont* pOldFont = dc.SelectObject(GetFont());
	// CRect cur_rec(lpDrawItemStruct->rcItem); // X-Ray :: Optimizations - Don't draw hidden Rect
	COLORREF crOldTextColor = dc.SetTextColor((lpDrawItemStruct->itemState & ODS_SELECTED) ? m_crHighlightText : m_crWindowText);
    if(client->GetSlotNumber() > theApp.uploadqueue->GetActiveUploadsCount()) {
        dc.SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
    }

	int iOldBkMode;
	if (m_crWindowTextBk == CLR_NONE){
		DefWindowProc(WM_ERASEBKGND, (WPARAM)(HDC)dc, 0);
		iOldBkMode = dc.SetBkMode(TRANSPARENT);
	}
	else
		iOldBkMode = OPAQUE;

	CHeaderCtrl *pHeaderCtrl = GetHeaderCtrl();
	int iCount = pHeaderCtrl->GetItemCount();
	cur_rec.right = cur_rec.left - 8;
	cur_rec.left += 4;
	CString Sbuffer;	
	for(int iCurrent = 0; iCurrent < iCount; iCurrent++){
		int iColumn = pHeaderCtrl->OrderToIndex(iCurrent);
		if( !IsColumnHidden(iColumn) ){
			cur_rec.right += GetColumnWidth(iColumn);
			if (cur_rec.left < clientRect.right && cur_rec.right > clientRect.left){ // X-Ray :: Optimizations - Only draw item if inside the display area
				switch(iColumn){
					case 0:{
						uint8 image;
						if (client->credits != NULL){
							// X-Ray :: Argos :: Start
							if (client->IsBanned()) 
								image = 27;
							else if(theApp.argos->IsArgos(client->GetConnectIP())){
								if (theApp.argos->GetPunishment(client) == 0) 
									image = 24;
								else if (theApp.argos->GetPunishment(client) == 1) 
									image = 26;
								else
									image = 25;
							}
							// X-Ray :: Argos :: End
							else if (client->IsFriend())
								image = 4;
							// X-Ray :: CorrectAppIcons :: Start
							else if (client->GetClientSoft() == SO_EMULE){
								if (client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 2;
								else
									image = 0;
							}
							// X-Ray :: CorrectAppIcons :: End
							else if (client->GetClientSoft() == SO_EDONKEYHYBRID){
								if (client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 8;
								else
									image = 7;
							}
							else if (client->GetClientSoft() == SO_MLDONKEY || client->GetClientSoft() == SO_MLDONKEY2 || client->GetClientSoft() == SO_MLDONKEY3){ // X-Ray :: EnhancedClientRecognization
								if (client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 6;
								else
									image = 5;
							}
							else if (client->GetClientSoft() == SO_SHAREAZA || client->GetClientSoft() == SO_SHAREAZA2 || client->GetClientSoft() == SO_SHAREAZA3 || client->GetClientSoft() == SO_SHAREAZA4){ // X-Ray :: EnhancedClientRecognization
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 10;
								else
									image = 9;
							}
							else if (client->GetClientSoft() == SO_AMULE){
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 12;
								else
									image = 11;
							}
							else if (client->GetClientSoft() == SO_LPHANT){
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 14;
								else
									image = 13;
							}
							// X-Ray :: EnhancedClientRecognization :: Start
							else if (client->GetClientSoft() == SO_EMULEPLUS){
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 19;
								else
									image = 18;
							}
							else if (client->GetClientSoft() == SO_HYDRANODE){
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 17;
								else
									image = 16;
							}
							else if (client->GetClientSoft() == SO_TRUSTYFILES){
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 21;
								else
									image = 20;
							}
							else if (client->GetClientSoft() == SO_XMULE){
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 23;
								else
									image = 22;
							}
							// X-Ray :: EnhancedClientRecognization :: End

							// X-Ray :: CorrectAppIcons :: Start
							/*
							else if (client->ExtProtocolAvailable()){
								if(client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 3;
								else
									image = 1;
							}
							else{
								if (client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 2;
								else
									image = 0;
							}
							*/
							// changed to Compatible Icons because if it's none of the App's above we don't have icons for it
							else {
								if (client->credits->GetScoreRatio(client->GetIP()) > 1)
									image = 3; 
								else
									image = 1;
							}
							// X-Ray :: CorrectAppIcons :: End
						}
						else
							image = 0;

						uint32 nOverlayImage = 0;
						if ((client->Credits() && client->Credits()->GetCurrentIdentState(client->GetIP()) == IS_IDENTIFIED))
							nOverlayImage |= 1;
						if (client->IsObfuscatedConnectionEstablished())
							nOverlayImage |= 2;
						POINT point = {cur_rec.left, cur_rec.top+1};
						m_ImageList.Draw(dc,image, point, ILD_NORMAL | INDEXTOOVERLAYMASK(nOverlayImage));

						// X-Ray :: CorrectAppIcons :: Start
						if(client->ExtProtocolAvailable())
							m_ImageList.Draw(dc, 15, point, ILD_TRANSPARENT);
						// X-Ray :: CorrectAppIcons :: End

						Sbuffer = client->GetUserName();

						// X-Ray :: IP2Country :: Start
						if(theApp.ip2country->ShowCountryFlag()){
							cur_rec.left+=20;
							POINT point2= {cur_rec.left,cur_rec.top+1};
							theApp.ip2country->GetFlagImageList()->Draw(dc, client->GetCountryFlagIndex(), point2, ILD_NORMAL);
						}
						// X-Ray :: IP2Country :: End

						cur_rec.left +=20;
						dc.DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DLC_DT_TEXT);
						cur_rec.left -=20;

						// X-Ray :: IP2Country :: Start
						if(theApp.ip2country->ShowCountryFlag())
							cur_rec.left-=20;
						// X-Ray :: IP2Country :: End
						break;
						}
					case 1:
						Sbuffer.Format(_T("%s"), client->GetClientSoftVer());
						// X-Ray :: ModID :: Start
						if (Sbuffer.IsEmpty())
							Sbuffer = GetResString(IDS_UNKNOWN);
						if (!client->GetClientModVer().IsEmpty())
							Sbuffer += _T(" [") + client->GetClientModVer() + _T(']');
						// X-Ray :: ModID :: End
						break;
					case 2:
						Sbuffer.Format(_T("%s"), client->GetRequestFile()->GetFileName());
						break;
					case 3:
						Sbuffer=CastItoXBytes( (float)client->GetDownloadDatarate() , false, true);
						dc.DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec, DLC_DT_TEXT | DT_RIGHT);
						break;
					case 4:
						cur_rec.bottom--;
						cur_rec.top++;
						// X-Ray :: MultiFileStatusbars :: Start
						/*
						client->DrawStatusBar(dc, &cur_rec, false, thePrefs.UseFlatBar());
						*/
						client->DrawStatusBar(dc, cur_rec, client->GetRequestFile(), thePrefs.UseFlatBar());
						// X-Ray :: MultiFileStatusbars
						cur_rec.bottom++;
						cur_rec.top--;
						break;	
					case 5:
						if(client->Credits() && client->GetSessionDown() < client->credits->GetDownloadedTotal())
							Sbuffer.Format(_T("%s (%s)"), CastItoXBytes(client->GetSessionDown()), CastItoXBytes(client->credits->GetDownloadedTotal()));
						else
							Sbuffer.Format(_T("%s"), CastItoXBytes(client->GetSessionDown()));
						break;
					case 6:
						if(client->Credits() && client->GetSessionUp() < client->credits->GetUploadedTotal())
							Sbuffer.Format(_T("%s (%s)"), CastItoXBytes(client->GetSessionUp()), CastItoXBytes(client->credits->GetUploadedTotal()));
						else
							Sbuffer.Format(_T("%s"), CastItoXBytes(client->GetSessionUp()));
						break;
					case 7:
						switch(client->GetSourceFrom()){
							case SF_SERVER:
								Sbuffer = _T("eD2K Server");
								break;
							case SF_KADEMLIA:
								Sbuffer = GetResString(IDS_KADEMLIA);
								break;
							case SF_SOURCE_EXCHANGE:
								Sbuffer = GetResString(IDS_SE);
								break;
							case SF_PASSIVE:
								Sbuffer = GetResString(IDS_PASSIVE);
								break;
							case SF_LINK:
								Sbuffer = GetResString(IDS_SW_LINK);
								break;
							// X-Ray :: SearchCatch :: Start
							case SF_SEARCH:
								Sbuffer = GetResString(IDS_SW_SEARCHBOX);
								break;
							// X-Ray :: SearchCatch :: End
							// X-Ray :: Sourcecache :: Start
							case SF_CACHE:
								Sbuffer = GetResString(IDS_SOURCECACHE);
								break;
							// X-Ray :: Sourcecache :: End
							// X-Ray :: SLS :: Start
							case SF_SLS:
								Sbuffer = GetResString(IDS_SLS);
								break;
							// X-Ray :: SLS :: End
							default:
								Sbuffer = GetResString(IDS_UNKNOWN);
								break;
						}
						break;
					// X-Ray :: IP2Country :: Start
					case 8:
						Sbuffer.Format(_T("%s"), client->GetCountryName());
						dc->DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DLC_DT_TEXT);
						break;
					// X-Ray :: IP2Country :: End
					// X-Ray :: Argos :: Start
					case 9:
						if(thePrefs.UseArgosSystem())
							Sbuffer = theApp.argos->GetArgosString(client);
						break;
					// X-Ray :: Argos :: End
				}
				if( iColumn != 4 && iColumn != 0 && iColumn != 3 && iColumn != 11)
					dc.DrawText(Sbuffer,Sbuffer.GetLength(),&cur_rec,DLC_DT_TEXT);
			}
			cur_rec.left += GetColumnWidth(iColumn);
		}
	}

	//draw rectangle around selected item(s)
	if (lpDrawItemStruct->itemState & ODS_SELECTED)
	{
		RECT outline_rec = lpDrawItemStruct->rcItem;

		outline_rec.top--;
		outline_rec.bottom++;
		dc.FrameRect(&outline_rec, &CBrush(GetBkColor()));
		outline_rec.top++;
		outline_rec.bottom--;
		outline_rec.left++;
		outline_rec.right--;

		if (bCtrlFocused)
			dc.FrameRect(&outline_rec, &CBrush(m_crFocusLine));
		else
			dc.FrameRect(&outline_rec, &CBrush(m_crNoFocusLine));
	}

	if (m_crWindowTextBk == CLR_NONE)
		dc.SetBkMode(iOldBkMode);

	dc.SelectObject(pOldFont);
	dc.SetTextColor(crOldTextColor);
}

void CDownloadClientsCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult){

	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// Barry - Store sort order in preferences
	// Determine ascending based on whether already sorted on this column
	bool sortAscending = (GetSortItem()!= pNMListView->iSubItem) ? (pNMListView->iSubItem == 0) : !GetSortAscending();	

	// Sort table
	UpdateSortHistory(pNMListView->iSubItem + (sortAscending ? 0:100), 100);
	SetSortArrow(pNMListView->iSubItem, sortAscending);
	SortItems(SortProc, pNMListView->iSubItem + (sortAscending ? 0:100));

	*pResult = 0;
}

BOOL CDownloadClientsCtrl::OnCommand(WPARAM wParam, LPARAM /*lParam*/)
{
	wParam = LOWORD(wParam);

	switch (wParam)
	{
		case MP_FIND:
			OnFindStart();
			return TRUE;
	}

	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	if (iSel != -1){
		CUpDownClient* client = (CUpDownClient*)GetItemData(iSel);
		switch (wParam){
			case MP_SHOWLIST:
				client->RequestSharedFileList();
				break;
			case MP_MESSAGE:
				theApp.emuledlg->chatwnd->StartSession(client);
				break;
			case MP_ADDFRIEND:
				if (theApp.friendlist->AddFriend(client))
					Update(iSel);
				break;
			// X-Ray :: StopDownload :: Start
			case MP_STOP_CLIENT: 
				StopSingleClient(client);
				break;
			// X-Ray :: StopDownload :: End
			case MP_DETAIL:
			case MPG_ALTENTER:
			case IDA_ENTER:
			{
				// X-Ray :: ModelessDialogs :: Start
				/*
				CClientDetailDialog dialog(client, this);
				dialog.DoModal();
				*/
				CClientDetailDialog* dlg = new CClientDetailDialog(client, this);
				dlg->OpenDialog();
				// X-Ray :: ModelessDialogs :: End
				break;
			}
			case MP_BOOT:
				if (client->GetKadPort())
					Kademlia::CKademlia::Bootstrap(ntohl(client->GetIP()), client->GetKadPort(), (client->GetKadVersion() > 1));
				break;
		}
	}
	return true;
}

int CDownloadClientsCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){
	const CUpDownClient* item1 = (CUpDownClient*)lParam1;
	const CUpDownClient* item2 = (CUpDownClient*)lParam2;
	int iResult=0;
	switch(lParamSort){
		case 0: 
		case 100:
			if(item1->GetUserName() && item2->GetUserName())
				iResult=CompareLocaleStringNoCase(item1->GetUserName(), item2->GetUserName());
			else if(item1->GetUserName())
				iResult=1;
			else
				iResult=-1;
			break;
		case 1:
	    case 101:
			// X-Ray :: ModID :: Start
			/*
			if (item1->GetClientSoft() == item2->GetClientSoft())
				iResult=item2->GetVersion() - item1->GetVersion();
			else 
				iResult=item1->GetClientSoft() - item2->GetClientSoft();
			break;
			*/
			if (item1->GetClientSoft() != item2->GetClientSoft())
				iResult=item2->GetClientSoft() - item1->GetClientSoft();
			else if (item1->GetVersion() != item2->GetVersion())
				iResult=item1->GetVersion() - item2->GetVersion();
			else 
				iResult=item1->GetClientModVer().CompareNoCase(item2->GetClientModVer());
			// X-Ray :: ModID :: End
			break;
		case 2:
		case 102:
		{
			CKnownFile* file1 = item1->GetRequestFile();
			CKnownFile* file2 = item2->GetRequestFile();
			if( (file1 != NULL) && (file2 != NULL))
				iResult=CompareLocaleStringNoCase(file1->GetFileName(), file2->GetFileName());
			else if( file1 == NULL )
				iResult=1;
			else
				iResult=-1;
			break;
		}
		case 3:
		case 103:
			iResult=CompareUnsigned(item1->GetDownloadDatarate(), item2->GetDownloadDatarate());
			break;
		case 4:
		case 104: 
			iResult=CompareUnsigned(item1->GetPartCount(), item2->GetPartCount());
			break;
		case 5:
		case 105:
			iResult=CompareUnsigned(item1->GetSessionDown(), item2->GetSessionDown());
			break;
		case 6:
		case 106:
			iResult=CompareUnsigned(item1->GetSessionUp(), item2->GetSessionUp());
			break;
		case 7: 
		case 107: 
			iResult=CompareUnsigned(item1->GetSourceFrom(), item2->GetSourceFrom());
			break;
		// X-Ray :: IP2Country :: Start
		case 8:
		case 108:
			iResult = CompareLocaleStringNoCase(item1->GetCountryName(true), item2->GetCountryName(true));
			break;
		// X-Ray :: IP2Country :: End
		// X-Ray :: Argos :: Start
		case 9:
		case 109:
			iResult=wcscmp(theApp.argos->GetArgosString(item1), theApp.argos->GetArgosString(item2));
			break;
		// X-Ray :: Argos :: End
		default:
			iResult=0;
			break;
	}

	if (lParamSort>=100)
    iResult*=-1;

	int dwNextSort;
	//call secondary sortorder, if this one results in equal
	//(Note: yes I know this call is evil OO wise, but better than changing a lot more code, while we have only one instance anyway - might be fixed later)
	if (iResult == 0 && (dwNextSort = theApp.emuledlg->transferwnd->downloadclientsctrl.GetNextSortOrder(lParamSort)) != (-1)){
		iResult= SortProc(lParam1, lParam2, dwNextSort);
	}

	return iResult;
}

//SLAHAM: ADDED [TPT] - New Menu Styles =>
void CDownloadClientsCtrl::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	const CUpDownClient* client = (iSel != -1) ? (CUpDownClient*)GetItemData(iSel) : NULL;

	CTitleMenu ClientMenu;
	ClientMenu.CreatePopupMenu();
	// X-Ray :: XPMenus :: Start
	/*
	ClientMenu.AddMenuTitle(GetResString(IDS_CLIENTS), true);
	*/
	ClientMenu.AddMenuTitle(GetResString(IDS_CLIENTS), true, false, true);
	// X-Ray :: XPMenus :: End
	ClientMenu.AppendMenu(MF_STRING | (client ? MF_ENABLED : MF_GRAYED), MP_DETAIL, GetResString(IDS_SHOWDETAILS), _T("CLIENTDETAILS"));
	ClientMenu.SetDefaultItem(MP_DETAIL);
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && !client->IsFriend()) ? MF_ENABLED : MF_GRAYED), MP_ADDFRIEND, GetResString(IDS_ADDFRIEND), _T("ADDFRIEND"));
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient()) ? MF_ENABLED : MF_GRAYED), MP_MESSAGE, GetResString(IDS_SEND_MSG), _T("SENDMESSAGE"));
	ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && client->GetViewSharedFilesSupport()) ? MF_ENABLED : MF_GRAYED), MP_SHOWLIST, GetResString(IDS_VIEWFILES), _T("VIEWFILES"));
	if (Kademlia::CKademlia::IsRunning() && !Kademlia::CKademlia::IsConnected())
		ClientMenu.AppendMenu(MF_STRING | ((client && client->IsEd2kClient() && client->GetKadPort()!=0) ? MF_ENABLED : MF_GRAYED), MP_BOOT, GetResString(IDS_BOOTSTRAP));
	ClientMenu.AppendMenu(MF_STRING | (GetItemCount() > 0 ? MF_ENABLED : MF_GRAYED), MP_FIND, GetResString(IDS_FIND), _T("Search"));

	// X-Ray :: StopDownload :: Start
	if (client && client->GetDownloadState() == DS_DOWNLOADING){
		ClientMenu.AppendMenu(MF_SEPARATOR);
		ClientMenu.AppendMenu(MF_STRING, MP_STOP_CLIENT, GetResString(IDS_STOP_CLIENT), _T("STOPDOWNLOAD"));
	}
	// X-Ray :: StopDownload :: End

	GetPopupMenuPos(*this, point);
	ClientMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	VERIFY( ClientMenu.DestroyMenu() ); // X-Ray :: XPMenus
}

void CDownloadClientsCtrl::ShowSelectedUserDetails(){
	POINT point;
	::GetCursorPos(&point);
	CPoint p = point; 
    ScreenToClient(&p); 
    int it = HitTest(p); 
    if (it == -1)
		return;

	SetItemState(-1, 0, LVIS_SELECTED);
	SetItemState(it, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
	SetSelectionMark(it);   // display selection mark correctly!

	CUpDownClient* client = (CUpDownClient*)GetItemData(GetSelectionMark());
	if (client){
		// X-Ray :: ModelessDialogs :: Start
		/*
		CClientDetailDialog dialog(client, this);
		dialog.DoModal();
		*/
		CClientDetailDialog* dlg = new CClientDetailDialog(client, this);
		dlg->OpenDialog();
		// X-Ray :: ModelessDialogs :: End
	}
}

void CDownloadClientsCtrl::OnNMDblclkDownloadClientlist(NMHDR* /*pNMHDR*/, LRESULT* pResult)
{
	int iSel = GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	if (iSel != -1) {
		CUpDownClient* client = (CUpDownClient*)GetItemData(iSel);
		if (client){
			// X-Ray :: ModelessDialogs :: Start
			/*
			CClientDetailDialog dialog(client, this);
			dialog.DoModal();
			*/
			CClientDetailDialog* dlg = new CClientDetailDialog(client, this);
			dlg->OpenDialog();
			// X-Ray :: ModelessDialogs :: End
		}
	}
	*pResult = 0;
}

void CDownloadClientsCtrl::OnSysColorChange()
{
	CMuleListCtrl::OnSysColorChange();
	SetAllIcons();
}

void CDownloadClientsCtrl::OnGetDispInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (theApp.emuledlg->IsRunning()){
		// Although we have an owner drawn listview control we store the text for the primary item in the listview, to be
		// capable of quick searching those items via the keyboard. Because our listview items may change their contents,
		// we do this via a text callback function. The listview control will send us the LVN_DISPINFO notification if
		// it needs to know the contents of the primary item.
		//
		// But, the listview control sends this notification all the time, even if we do not search for an item. At least
		// this notification is only sent for the visible items and not for all items in the list. Though, because this
		// function is invoked *very* often, no *NOT* put any time consuming code here in.

		if (pDispInfo->item.mask & LVIF_TEXT){
			const CUpDownClient* pClient = reinterpret_cast<CUpDownClient*>(pDispInfo->item.lParam);
			if (pClient != NULL){
				switch (pDispInfo->item.iSubItem){
					case 0:
						if (pClient->GetUserName() != NULL && pDispInfo->item.cchTextMax > 0){
							_tcsncpy(pDispInfo->item.pszText, pClient->GetUserName(), pDispInfo->item.cchTextMax);
							pDispInfo->item.pszText[pDispInfo->item.cchTextMax-1] = _T('\0');
						}
						break;
					default:
						// shouldn't happen
						pDispInfo->item.pszText[0] = _T('\0');
						break;
				}
			}
		}
	}
	*pResult = 0;
}

// X-Ray :: StopDownload :: Start
void CDownloadClientsCtrl::StopSingleClient(CUpDownClient* pClient)  
{
	if(pClient != NULL && pClient->GetDownloadState() == DS_DOWNLOADING) {
		if(pClient->socket != NULL)
			pClient->SendCancelTransfer();
		pClient->SetDownloadState(DS_ONQUEUE, _T("Download aborted by User"));
	}
}
// X-Ray :: StopDownload :: End